UNIT OpenDlg;

// Simple File Open dialog - very lightweight compared to TOpenFile

INTERFACE

uses
  Windows;

function OpenDialog(hParent: HWnd; sTitle,sInitialDir, sFilter: String;
  var sFileName: String): Boolean;

IMPLEMENTATION

uses
  SysUtils, CommDlg, ShlObj;

function FixFilterStr(sFilter: String): String;
var
  i: Integer;
begin
  Result:=sFilter;
  for i:=1 to Length(sFilter) do
    if (Result[i] = '|') then
      Result[i]:=#0;
  Result:=Result+#0; // Double null terminators
end;

function OpenDialog(hParent: HWnd; sTitle,sInitialDir, sFilter: String;
  var sFileName: String): Boolean;
var
  ofn: TOpenFileName;
  szFile: Array[0..MAX_PATH] of Char;
begin
  Result:=false;
  FillChar(ofn,SizeOf(TOpenFileName),0);
  with ofn do
    begin
      lStructSize:=SizeOf(TOpenFileName);
      hwndOwner:=hParent;
      lpstrFile:=szFile;
      nMaxFile:=SizeOf(szFile);
      if (sTitle <> '') then
        lpstrTitle:=PChar(sTitle);
      if (sInitialDir <> '') then
        lpstrInitialDir:=PChar(sInitialDir);
      StrPCopy(lpstrFile,sFileName);
      sFilter:=FixFilterStr(sFilter);
      lpstrFilter:=PChar(sFilter);
      Flags:=OFN_HIDEREADONLY or OFN_FILEMUSTEXIST or OFN_EXPLORER or OFN_ENABLESIZING;
    end;
  if GetOpenFileName(ofn) then
    begin
      sFileName:=StrPas(szFile);
      Result:=true;
    end;
end;

end.
